/*****************************************************************************

**      **   **
****  ****    **
** **** **     **
**  **  **      **      $RCSfile: cvview.C,v $
**      **     **
**      **    **
**      **   **

	By:	Jon Goldman
	
	Date:
	
Modification Date:  $Date: 1995/07/21 00:31:22 $
	
Description:

Revisions:


*****************************************************************************/

/***** include files *****/

#include "cvviewer.h"

#include <cave.h>
#include <gl/gl.h>
#include <gl/device.h>

#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include "cvviewer.h"

/***** macros or const (c++) *****/

/***** function prototypes *****/

void app_shared_init(int argc, char *argv[]), app_compute_init(),
app_init_gl(), app_draw(),
app_compute();
extern void InventorFrameFunction();	// InventorFrameFunction in ivdraw.C

/***** typedefs or classes (c++) *****/

/***** storage *****/
char fileName[1024]="";
XWindowAttributes	winAtts;

CvViewer *cvviewer;
static char revNum[]="CAVE Inventor viewer, $Revision: 1.39 $";

extern CvViewer *cvviewer;

/**********************************************************************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
***********************************************************************************************/

void main(int argc,char **argv)
{
    cerr << "CAVE Inventor viewer, " << revNum << endl;
    CAVEConfigure(&argc,argv,NULL);
    app_shared_init(argc, argv);
    CAVEInit();
    CAVEInitApplication(app_init_gl,0);
    CAVEFrameFunction(InventorFrameFunction,0);
    CAVEDisplay(app_draw,0);
    app_compute_init();
    while (!getbutton(ESCKEY))
      app_compute();
    CAVEExit();
}

void app_shared_init(int argc, char *argv[])
{
    cvviewer = new CvViewer(argc, argv);
    // find the bounding
}

void app_compute_init() {  }

void app_init_gl()
{
    void InitOpenGLStuff(void);

    InitOpenGLStuff();

    // set the far clipping plane
    CAVEFar = 100000.0;
    cerr << endl << endl << "Set far clipping plane to: " << CAVEFar << endl;
}

void app_draw()
{
    void DrawInventorObjs(void);

    //cerr << "Far clipping plane is: " << CAVEFar << endl << flush;

    // save the OpenGL rendering attributes
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    
    // clear the screen and the depth buffer
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    //glClear(GL_COLOR_BUFFER_BIT);

    DrawInventorObjs();

    // restore the OpenGL attributes
    glPopAttrib();
}

/*  Initialize depth buffer, projection matrix, light source, 
 *  and lighting model.  Do not specify a material property here.
 */
void myinit(void)
{
}

void app_compute()
{
    cvviewer->interface->Process();
}
