/*****************************************************************************

**      **   **
****  ****    **
** **** **     **
**  **  **      **      $RCSfile: wand.C,v $
**      **     **
**      **    **
**      **   **

	By:	Jon Goldman
	
	Date:
	
Modification Date:  $Date: 1995/07/21 00:31:22 $
	
Description:

Revisions:


*****************************************************************************/

/***** include files *****/
#include <iostream.h>
#include <cave.h>
#include <cave.macros.h>
#include "cvviewer.h"
#include "wand.h"

/***** macros or const (c++) *****/

/***** function prototypes *****/

/***** typedefs or classes (c++) *****/

/***** storage *****/

/**********************************************************************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
***********************************************************************************************/

WandButton::WandButton()
{
    button_state = FALSE;
    button_was_off = TRUE;
    button_pressed = FALSE;
    button_released = FALSE;
}

void WandButton::ResetState()
{
    button_pressed = FALSE;
}

int WandButton::ButtonPressed()
{
    if (button_pressed)
      {
	  button_pressed = FALSE;
	  return TRUE;
      }
    else
      return FALSE;
}


int WandButton::ButtonReleased()
{
    if (button_released)
      {
	  button_released = FALSE;
	  return TRUE;
      }
    else
      return FALSE;
}

int WandButton::ButtonOn()
{
    if (button_on)
      return TRUE;
    else
      return FALSE;
}


void WandButton::State()
{
    button_drag = FALSE;
    if (button_on)
    {
	if (button_was_off)
	{
	    button_was_off = FALSE;
	    button_pressed = TRUE;
 	}
	button_drag = TRUE;
    }
    else
    {
	if (! button_was_off)
	    button_released = TRUE;
        button_was_off = TRUE;
    }
}

void WandButton1::ButtonState()
{
    button_on = (CAVEBUTTON1 == ON && CAVEBUTTON2 == OFF && CAVEBUTTON3 == OFF);
    State();
}

void WandButton2::ButtonState()
{
    button_on = (CAVEBUTTON1 == OFF && CAVEBUTTON2 == ON && CAVEBUTTON3 == OFF);
    State();
}

void WandButton3::ButtonState()
{
    button_on = (CAVEBUTTON1 == OFF && CAVEBUTTON2 == OFF && CAVEBUTTON3 == ON);
    State();
}

Wand::Wand()
{
    but[0] = new WandButton1;
    but[1] = new WandButton2;
    but[2] = new WandButton3;
}

void Wand::ResetButtonStates()
{
    int ii;
    
    for (ii=0;ii<num_buttons;ii++)
      but[ii]->ResetState();
}

void Wand::WandState()
{
    int ii;

    for (ii=0;ii<num_buttons;ii++)
      but[ii]->ButtonState();
    
    CAVEGetWand(wandX,wandY,wandZ);
    CAVEGetWandFront(wandVect[0], wandVect[1], wandVect[2]);
    CAVEGetWandOrientation(azi, elev, roll);
    //cerr << "(azi,elev,roll) = (" << azi << "," << elev << "," << roll << ")" << endl;
}

void Wand::WandControl()
{
    WandState();
}

int Wand::ButtonPressed(int bnum)
{
    return but[bnum-1]->ButtonPressed();
}

int Wand::ButtonReleased(int bnum)
{
    return but[bnum-1]->ButtonReleased();
}

int Wand::ButtonOn(int bnum)
{
    return but[bnum-1]->ButtonOn();
}

