/*****************************************************************************

**      **   **
****  ****    **
** **** **     **
**  **  **      **      $RCSfile: ivload.C,v $
**      **     **
**      **    **
**      **   **

	By:	Jon Goldman
	
	Date:
	
Modification Date:  $Date: 1995/07/21 00:31:22 $
	
Description:

Revisions:


*****************************************************************************/

/***** include files *****/

// inventor stuff
#include <Inventor/SoDB.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoPointLight.h>
#include <Inventor/nodes/SoLightModel.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoSphere.h>

#include <stdlib.h>
#include <iostream.h>

// necessary X stuff
#include <X11/Xlib.h>

#include <cave.h>

/***** macros or const (c++) *****/

/***** function prototypes *****/

/***** typedefs or classes (c++) *****/

/***** storage *****/


/**********************************************************************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
***********************************************************************************************/

void BuildInventorScene(char *filename, SoSeparator *root)
{
    void LoadScene(char *filename, SoSeparator *root);
    LoadScene(filename, root);
}

void LoadScene(char *filename, SoSeparator *root)
{
    SoGroup *readFile(const char *filename);
    
    SoSeparator *fileScene = new SoSeparator;
    SoGroup *filegeom;
    filegeom = readFile(filename);
    if (filegeom == NULL)
      {
	  cerr << "Can not read inventor file " << filename << endl;
      }
    else
      {
	  cerr << "Adding inventor database from " << filename << " to root" << endl;
	  fileScene->addChild(filegeom);
      }

    root->addChild(fileScene);
}

SoGroup *readFile(const char *filename)
{
    // Open the input file
    SoInput mySceneInput;
    if (!mySceneInput.openFile(filename))
      {
	  fprintf(stderr, "Cannot open file %s\n", filename);
	  exit(1);
	  return NULL;
      }
    SoGroup *myGraph=NULL;

    // Read the whole file into the database
    myGraph = SoDB::readAll(&mySceneInput);
    
    if (myGraph == NULL)
      {
	  fprintf(stderr, "Problem reading file\n");
	  return NULL;
      }
    mySceneInput.closeFile();
    return myGraph;
}
