/*****************************************************************************

**      **   **
****  ****    **
** **** **     **
**  **  **      **      $RCSfile: mode.C,v $
**      **     **
**      **    **
**      **   **

	By:	Jon Goldman
	
	Date:
	
Modification Date:  $Date: 1995/07/21 00:31:22 $
	
Description:

Revisions:


*****************************************************************************/

/***** include files *****/
#include <iostream.h>
#include "cvviewer.h"
#include "mode.h"

/***** macros or const (c++) *****/

/***** function prototypes *****/

/***** typedefs or classes (c++) *****/

/***** storage *****/
extern CvViewer *cvviewer;
char Mode::ModeStrs[numModes][256]={"NAV","Datasets","Scale"};

/**********************************************************************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
***********************************************************************************************/

Mode::Mode(int numFilesin)
{
    title = new SoText3();
    title->ref();
    curMode = 0;
    numFiles = numFilesin;
    fileMask = numFiles;

    myFont = new SoFont;
    myFont->ref();
    myFont->name.setValue("Times-Roman");
    myFont->size.setValue(1.0);
    title->string.setValue(&ModeStrs[curMode][0]);
    title->parts = SoText3::ALL;
    titleTrans = new SoTransform;
    titleTrans->translation.setValue(1.5,.25,-5);
    titleTrans->ref();          // add a reference so that it doesn't get deleted outside this routine
}

void Mode::Bump()
{
    curMode = (++curMode % numModes);
    cvviewer->interface->wand->ResetButtonStates();
    title->string.setValue(&ModeStrs[curMode][0]);
}

void Mode::FileMaskDown()
{
    fileMask--;
    if (fileMask < 0) fileMask = 0;
}

void Mode::FileMaskUp()
{
    fileMask++;
    if (fileMask > numFiles) fileMask = numFiles;
}
