#ifndef include_mode
#define include_mode

/*****************************************************************************

**    **   **
**    **    **
**    **     **
********      **     $RCSfile: mode.h,v $
**    **     **
**    **    **
**    **   **

Author:  Jon Goldman
Date:    

Modification Date:  $Date: 1995/07/21 00:31:22 $

Description:

Revisions:

  Date		Who	Description
  ----     	---   	-----------

*/

/***** include files *****/
#include <Inventor/nodes/SoFont.h>
#include <Inventor/nodes/SoText3.h>
#include <Inventor/nodes/SoTransform.h>

/***** macros or const *****/
#define numModes 	3

/***** function prototypes *****/

/***** data structures or classes *****/
class Mode
{
  public:
    // Constructors
    Mode(int numFiles);

    // Destructor

    // public member functions
    void Bump();
    int CurMode();
    void FileMaskDown();
    void FileMaskUp();

    // public Accessor functions

    // public static class members and functions

    static char ModeStrs[numModes][256];

    // public members
    SoText3	*title;
    SoFont	*myFont;
    SoTransform	*titleTrans;
    int fileMask;

  protected:
    // protected member functions

    // protected Accessor functions

    // protected static class members and functions

    // protected members
    int curMode;
    int numFiles;
      
  private:

  // friend functions or classes
};

inline Mode::CurMode() { return curMode; }
    
#endif	/* include_mode */
