#ifndef include_wand
#define include_wand

/*****************************************************************************

**    **   **
**    **    **
**    **     **
********      **     $RCSfile: wand.h,v $
**    **     **
**    **    **
**    **   **

Author:  Jon Goldman
Date:    

Modification Date:  $Date: 1995/07/21 00:31:22 $

Description:

Revisions:

  Date		Who	Description
  ----     	---   	-----------

*/

/***** include files *****/

/***** macros or const *****/
static const int num_buttons=3;

#ifndef TRUE
static const int TRUE=1;
#endif

#ifndef FALSE
static const int FALSE=0;
#endif

/***** function prototypes *****/

/***** data structures or classes *****/

class WandButton
{
  public:
    // Constructors
    WandButton();

    // Destructor

    // public member functions
    int ButtonPressed();
    int ButtonReleased();
    int ButtonOn();
    virtual void ButtonState()=0;
    void State();
    void ResetState();

    // public Accessor functions

    // public static class members and functions

    // public members

  protected:
    // protected member functions

    // protected Accessor functions

    // protected static class members and functions

    // protected members
    int button_state;
    int button_drag;
    int button_pressed;
    int button_was_off;
    int button_released;
    int	button_on;
      
  private:

  // friend functions or classes
};

class WandButton1 : public WandButton
{
  public:
    // Constructors

    // Destructor

    // public member functions
    virtual void ButtonState();

    // public Accessor functions

    // public static class members and functions

    // public members

  protected:
    // protected member functions

    // protected Accessor functions

    // protected static class members and functions

    // protected members
      
  private:

  // friend functions or classes
};

class WandButton2 : public WandButton
{
  public:
    // Constructors

    // Destructor

    // public member functions
    virtual void ButtonState();

    // public Accessor functions

    // public static class members and functions

    // public members

  protected:
    // protected member functions

    // protected Accessor functions

    // protected static class members and functions

    // protected members
      
  private:

  // friend functions or classes
};

class WandButton3 : public WandButton
{
  public:
    // Constructors

    // Destructor

    // public member functions
    virtual void ButtonState();

    // public Accessor functions

    // public static class members and functions

    // public members

  protected:
    // protected member functions

    // protected Accessor functions

    // protected static class members and functions

    // protected members
      
  private:

  // friend functions or classes
};

class Wand
{
  public:
    // Constructors
    Wand();

    // Destructor

    // public member functions
    void WandControl();
    void WandState();
    int ButtonPressed(int bnum);
    int ButtonReleased(int bnum);
    int ButtonOn(int bnum);
    void ResetButtonStates();

    // public Accessor functions

    // public static class members and functions

    // public members
    float wandX,wandY,wandZ;
    float wandVect[3];
    float azi, elev, roll;

  protected:
    // protected member functions

    // protected Accessor functions

    // protected static class members and functions

    // protected members
    WandButton *but[num_buttons];

  private:

  // friend functions or classes
};

#endif	/* include_wand */
